[tox]
skip_missing_interpreters = True
skipsdist = True
envlist =
    py27
    py36
    py37
    py38
    py39
    py310
    cov-report

[pytest]
doctest_optionflags = IGNORE_EXCEPTION_DETAIL ALLOW_UNICODE ALLOW_BYTES ELLIPSIS

[testenv]
deps =
    -rtests/requirements.txt
    -e .
setenv =
    COVERAGE_FILE = .coverage.{envname}
    SETUP_CEXT_REQUIRED = 1
passenv =
    CFLAGS
    CPPFLAGS
    LDFLAGS
    PKG_CONFIG_PATH
commands =
    py.test -vv -s -c test.ini \
        --cov=rcssmin \
        --cov-config=test.ini \
        --cov-report= \
        --no-cov-on-fail \
        --doctest-modules --color=yes \
        tests

[testenv:cov-report]
deps = -rtests/coverage.txt

setenv =
    COVERAGE_FILE = .coverage
commands =
    coverage erase
    coverage combine
    coverage report --rcfile test.ini
    coverage html --rcfile test.ini
    - python -c 'import sys, os; os.mkdir(sys.argv[1])' "docs/gcov"
    - gcovr --print-summary --html-details --output docs/gcov/index.html


[run]
branch = True

[report]
# Regexes for lines to exclude from consideration
exclude_lines =
    # Have to re-enable the standard pragma
    pragma: no cover

    # Don't complain about missing debug-only code:
    if self\.debug

    # Don't complain if tests don't hit defensive assertion code:
    raise NotImplementedError

    # Don't complain if non-runnable code isn't run:
    if 0:
    if __name__ == .__main__.:

# Special part-branch exclusion
partial_branches =
    # Re-enable standard pragma
    pragma: no branch

# Source files to exclude
omit =

ignore_errors = True

[html]
directory = docs/coverage


# vim: nowrap
